
!MAOptionDescription methodsFor: 'private' stamp: 'lr 3/28/2007 10:28'!
prepareOptions: aCollection
	^ self isSorted
		ifFalse: [ aCollection asArray ]
		ifTrue: [ aCollection asArray sort: self sortBlock ]! !

!String methodsFor: '*magritte-model-accessing' stamp: 'lr 3/28/2007 10:32'!
lines
	"Retrun a collection with the string-lines of the receiver."

	| input |
	input := self readStream.
	^ Array streamContents: [ :output |
		[ input atEnd ] whileFalse: [
			output nextPut: (input upTo: Character cr).
			input peek = Character lf
				ifTrue: [ input next ] ] ]! !

!MATableModel methodsFor: 'enumeration' stamp: 'lr 3/28/2007 10:28'!
collect: aBlock
	| copy |
	copy := self copyEmpty.
	self do: [ :row :col :val |
		copy
			at: row at: col
			put: (aBlock value: row value: col value: val) ].
	^ copy! !

!MADistribution class methodsFor: 'accessing-dynamic' stamp: 'lr 3/28/2007 10:26'!
versionNumber
	| input |
	input := self version allButFirst readStream.
	^ String streamContents: [ :output |
		[ input atEnd or: [ input peek isString ] ]
			whileFalse: [ output print: input next; nextPut: $. ].
		output skip: -1.
		input atEnd
			ifFalse: [ output nextPut: $-; nextPutAll: input next ] ]! !

!MABinaryReader methodsFor: 'private' stamp: 'lr 3/28/2007 10:26'!
next
	| description |
	self version: self stream next.
	self version isInteger
		ifFalse: [ self error: 'Invalid File Format.' ].
	description := self stream next.
	description isDescription
		ifFalse: [ self error: 'Invalid File Description.' ].
	description class version <= self version
		ifFalse: [ self error: 'Invalid File Version.' ].
	self visit: description.
	^ self object! !

!MAExternalFileModel methodsFor: 'copying' stamp: 'lr 3/28/2007 10:27'!
postCopy
	| previous |
	super postCopy.
	previous := self contents.
	location := nil.
	self contents: previous! !
