
!MAOptionDescription methodsFor: 'private' stamp: 'lr 3/9/2006 11:32'!
prepareOptions: aCollection
	^ aCollection asArray in: [ :result |
		self isSorted
			ifTrue: [ result sort: self sortBlock ]
			ifFalse: [ result ] ]! !

!String methodsFor: '*magritte-model-accessing' stamp: 'lr 3/9/2006 11:31'!
lines
	"Retrun a collection with the string-lines of the receiver."

	^ Array streamContents: [ :output |
		self readStream in: [ :input |
			[ input atEnd ] whileFalse: [
				output nextPut: (input upTo: Character cr).
				input peek = Character lf
					ifTrue: [ input next ] ] ] ]! !

!MATableModel methodsFor: 'enumeration' stamp: 'lr 3/9/2006 11:32'!
collect: aBlock
	^ self copyEmpty in: [ :table |
		self do: [ :row :col :val |
			table
				at: row at: col
				put: (aBlock value: row value: col value: val) ].
		table ]! !

!MADistribution class methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:33'!
versionNumber
	^ String streamContents: [ :output |
		self version allButFirst readStream in: [ :input |
			[ input atEnd or: [ input peek isString ] ]
				whileFalse: [ output print: input next; nextPut: $. ].
			output skip: -1.
			input atEnd
				ifFalse: [ output nextPut: $-; nextPutAll: input next ] ] ]! !

!MABinaryReader methodsFor: 'private' stamp: 'lr 3/9/2006 11:31'!
next
	self version: self stream next.
	self version isInteger
		ifFalse: [ self error: 'Invalid File Format.' ].
	self stream next in: [ :description |
		description isDescription
			ifFalse: [ self error: 'Invalid File Description.' ].
		description class version <= self version
			ifFalse: [ self error: 'Invalid File Version.' ].
		self visit: description ].
	^ self object! !

!MAExternalFileModel methodsFor: 'copying' stamp: 'lr 1/26/2007 18:24'!
postCopy
	super postCopy.
	self contents in: [ :contents |
		location := nil.
		self contents: contents ]! !
